【LeetCode从零单刷】Longest Consecutive Sequence

题目:

Given an unsorted array of integers, find the length of the longest consecutive elements sequence.

For example,
Given [100, 4, 200, 1, 3, 2],
The longest consecutive elements sequence is [1, 2, 3, 4]. Return its length: 4.

Your algorithm should run in O(n) complexity.

解答;

O(n) 的时间复杂度看到,就猜到是不是用动态规划。然后想了很长时间找不到状态转移方程……

结果 Discuss 里面都是用容器来计算(O(n) 不一定是DP,也可以考虑容器)。因为这段序列可能是有重复元素的,所以使用 set 相关的容器可以避免容器中包含重复元素。

但是,set / map 是基于红黑树实现的,因此查找效率是 O(log n) 级别的;因此,可以使用基于 hashmap 的 unordered_set 容器,查找效率是常数级别

设定一个容器,保存已经访问过的元素。每个元素遍历它 ++ 以及 -- 部分。

class Solution {
public:
    int longestConsecutive(vector<int>& nums) {
        unordered_set<int> visited;
        unordered_set<int> all(nums.begin(), nums.end());
        
        int max = 0;
        int count, tmp;
        int size = nums.size();
        for(int i=0; i<size; i++) {
            if (visited.find(nums[i]) != visited.end()) continue;
            
            visited.insert(nums[i]);
            count = 1;
            
            tmp = nums[i];
            while(all.find(tmp - 1) != all.end()) {
                count++;
                tmp--;
                visited.insert(tmp);
            }
            
            tmp = nums[i];
            while(all.find(tmp + 1) != all.end()) {
                count++;
                tmp++;
                visited.insert(tmp);
            }
            
            if (count > max) max = count;
        }
        return max;
    }
};

你可能感兴趣的:(LeetCode,C++,HashMap,unordered_set)